macroScript Morpher_KeySelected category:"Morpher" tooltip:"Morpher Key All"
(

------------------------------------------
--Morpher_KeySelected MACROSCRIPT v 0.1
--Created:6/14/99
--Edited:6/14/99
--by Borislav Petrov
--bobo@email.archlab.tuwien.ac.at
------------------------------------------

global mks_nf
local used_channels = #()

rollout morph_keysel "Select Targets to Key"
(
	fn morph_filter ob =
	(
	try
		(
		a = ob.morpher
		return true
		)
	catch 
		(
	return false
		)
	)--end filter

pickbutton get_morph "Pick Morphed Object" width:140 filter:morph_filter align:#center
checkbox auto_select "Auto-Select All Targets" checked:true
button set_keys "Key Selected Targets" width:140 height:30 align:#center enabled:false

on get_morph picked obj do
	(
	work_node = obj
	get_morph.text = obj.name
	set_keys.enabled = true
	used_channels = #()
	select_array = #()
	for i = 1 to 100 do if findstring (work_node.morpher[i] as string) "empty" == undefined then 
	(
	target_name = work_node.morpher[i] as string
	start_name = findstring target_name "__"
	end_name = findstring target_name "___"
	final_name = substring target_name (start_name+2) (end_name-start_name-2)
	used_channels[i] = (execute ("$"+final_name))
	append select_array (execute ("$"+final_name))
	)
	if auto_select.checked then select select_array
	)

on set_keys pressed do
	(
	sel_array = selection as array
	new_sel_array = #()
	for i in sel_array do
		(
		find_target = findItem used_channels i 
		if find_target > 0 then 
			(
			addNewKey work_node.morpher[find_target] currentTime
			append new_sel_array i
			)
		)
		select new_sel_array
	)

)--end rollout


if mks_nf != undefined then closerolloutfloater mks_nf
mks_nf = newrolloutfloater "MorphKeySelected" 175 140 200 200
addrollout morph_keysel mks_nf


)--end script
